#include <stm32f10x_lib.h>
#include <stdio.h>
#include <i2c.h>
#include <gy521.h>
#include <uart.h>
#include <disp.h>
#include <motor.h>
#include <angle.h>
#include "balance.c"
#include "control.c"

int flag_disp=0;        //ʱͨ˱֪ͨѭˢʾ1-ˢ
int disp_type = 0;      //0-ʾ棬1-ֱʾ

int fputc(int ch, FILE *f)
{
    USART_SendData(USART2, (u8)ch);
    while (SET!=USART_GetFlagStatus(USART2, USART_FLAG_TC));
    return (ch);
}

void delay_init() //ϵͳʱѯʽʱ
{
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8); //óAHB8ƵҲ9MHz
    SysTick_ITConfig(DISABLE);
}
void udelay(u32 n) //ʱus뷶Χ 1~1864135
{
    //SysTickʱΪ9MHzʱ1usҪõļĴ 9
    u32 reg;
    reg = 9*n;
    SysTick_CounterCmd(SysTick_Counter_Clear); //ռ
    SysTick_SetReload(reg); //üĴ
    SysTick_CounterCmd(SysTick_Counter_Enable); //
    while(SysTick_GetFlagStatus(SysTick_FLAG_COUNT) == RESET); //ȴʱ
    SysTick_CounterCmd(SysTick_Counter_Disable); //ֹͣʱ
}
void mdelay(u16 n) //ʱms뷶Χ 1~1864
{
    //SysTickʱΪ9MHzʱ1msҪõļĴ 9000
    u32 reg;
    reg = 9000*n;
    SysTick_CounterCmd(SysTick_Counter_Clear); //ռ
    SysTick_SetReload(reg); //üĴ
    SysTick_CounterCmd(SysTick_Counter_Enable); //
    while(SysTick_GetFlagStatus(SysTick_FLAG_COUNT) == RESET); //ȴʱ
    SysTick_CounterCmd(SysTick_Counter_Disable); //ֹͣʱ
}
int test_pin = 0;
void test_pin_init()
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    {
        GPIO_InitTypeDef temp;
        temp.GPIO_Speed = GPIO_Speed_50MHz;
        temp.GPIO_Mode = GPIO_Mode_Out_PP;
        temp.GPIO_Pin = GPIO_Pin_12;
        GPIO_Init(GPIOB, &temp);
    }
}
void set_test_pin(int a)
{
    if(a)
    {
        GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_SET);
        test_pin = 1;
    }
    else
    {
        GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_RESET);
        test_pin = 0;
    }
}
void turn_test_pin()
{
    if(!test_pin)
    {
        GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_SET);
        test_pin = 1;
    }
    else
    {
        GPIO_WriteBit(GPIOB, GPIO_Pin_12, Bit_RESET);
        test_pin = 0;
    }
}

void RCC_init()
{
    ErrorStatus HSEStartUpStatus;    //Ϊ洢HSEʼ״̬ʱ
    RCC_DeInit();    //λ
    RCC_HSEConfig(RCC_HSE_ON);    //ⲿپHSE
    HSEStartUpStatus = RCC_WaitForHSEStartUp();    //ȴHSEokʧ
    if(HSEStartUpStatus == SUCCESS)    //ok
    {
        //PLL
        RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);    //PLLʱΪHSE/19ƵHSE8MHzPLLΪ72MHz
        RCC_PLLCmd(ENABLE);        //ʹPLL
        while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);    //ȴPLLȶ
     
        //Flashע⣡SYSCLKʼ֮ǰһҪflashʱںԤȡָ
        FLASH_SetLatency(FLASH_Latency_2);    //ʱ
        /*FLASHʱӳټڣȴͬ
          ƼյƬϵͳƵʣMHzʱȡLatency=0
          24MHzʱȡLatency=1
          48~72MHzʱȡLatency=2*/
        FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);    //Ԥȡָʹ
     
        //SYSCLK
        RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);    //ѡPLLʱΪSYSCLKʱԴ
        while(RCC_GetSYSCLKSource() != 0x08);        //ȴPLLʱӳΪSYSCLKʱԴ
        //AHB
        RCC_HCLKConfig(RCC_SYSCLK_Div1);    //AHBʱԴΪSYSCLK 1ƵҲ72MHz
        RCC_PCLK1Config(RCC_HCLK_Div2);        //APB1ΪHCLK 2ƵҲ36MHz
        RCC_PCLK2Config(RCC_HCLK_Div1);        //APB2ΪHCLK 1ƵҲ72MHz
    }
}

void timer2_init()
{
    /* ʹܶʱʱģ顣
       ߼ʱTIM1TIM8ڸʱAPB2ϣͨöʱTIM2~TIM7ڵʱAPB1ϡ
       ȻͬĶʱܹڲͬAPBϣͨAPBУʱʱӶ72MHzϸԭʼǣ */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
    /* öʱʱԴ */
    // ʱĬʱͨAPBģﲻҪ
    /* öʱԪ */
    {
        TIM_TimeBaseInitTypeDef temp;
        temp.TIM_Prescaler = 72-1;  /* ԤƵĴ[0, 65535]ǸtimAPBƵʶ72MHz
                                       72Mhz/(TIM_Prescaler+1) = CK_CNTʱƵʣTIM_Prescaler = 72MHz/CK_CNT - 1 */
        temp.TIM_Period = 20000-1;     /* ԶװؼĴ[0, 65535]
                                          ԤƵúüں(1/CK_CNT)ڵ(TIM_Period+1)Ǽڡ*/
        //һڹʽ = (TIM_Prescaler+1)*(TIM_Period+1)/72000000λs
        temp.TIM_CounterMode = TIM_CounterMode_Up; /* ģʽ
                                                      TIM_CounterMode_Up                TIM ϼģʽ
                                                      TIM_CounterMode_Down              TIM ¼ģʽ
                                                      TIM_CounterMode_CenterAligned1    TIM ģʽ 1 ģʽ
                                                      TIM_CounterMode_CenterAligned2    TIM ģʽ 2 ģʽ
                                                      TIM_CounterMode_CenterAligned3    TIM ģʽ 3 ģʽ  */
        temp.TIM_ClockDivision = TIM_CKD_DIV1; /* Ƶ벶ʱʹá */
        TIM_TimeBaseInit(TIM2, &temp);
    }
    /* öʱжϣж */
    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);
    /* nvicǰѾڳʼִ NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2) ˷ */
    {
        NVIC_InitTypeDef temp;
        temp.NVIC_IRQChannel = TIM2_IRQChannel;
        temp.NVIC_IRQChannelPreemptionPriority = 1;
        temp.NVIC_IRQChannelSubPriority = 1;
        temp.NVIC_IRQChannelCmd = ENABLE;
        NVIC_Init(&temp);
    }
    /* ʹܶʱ */
    TIM_Cmd(TIM2, ENABLE);
}
void TIM2_IRQHandler(void)      //20msһж
{
    set_test_pin(1);
    if(TIM_GetITStatus(TIM2, TIM_IT_Update) == SET)     //¼
    {
        static int count = 0;
        count ++;
        if(count == 5)  //100ms
        {
            count = 0;
            flag_disp = 1;
        }
        balance_tick();
        
        TIM_ClearITPendingBit(TIM2, TIM_FLAG_Update);  // һҪ־λ
        //жʲôҲֻҪtimжϴˣжϴһҪһѱ־λܻӰ쵽ģ鶼
    }
    set_test_pin(0);
}

int main(int argc, char *argv[])
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    RCC_init();
    delay_init();
    test_pin_init();
    uart2_init();
    i2c_init();
    mdelay(500);mpu6050_init();
    motor_init();
    angle_init();
    timer2_init();
    balance_init();

    motor_setzkb(100);
    disp_clean();
    while(1)
    {
        if(flag_disp)
        {
            flag_disp = 0;
            if(disp_type == 0)  //ʾ
            {
                disp_gotoxy(1,1);
                disp_clean_line();
                printf("sensordata: ax=%.3f \tay=%.3f \taz=%.3f \tgx=%.3f \tgy=%.3f \tgz=%.3f\n\r", sensor_raw_data.ax, sensor_raw_data.ay, sensor_raw_data.az, sensor_raw_data.gx, sensor_raw_data.gy, sensor_raw_data.gz);
                disp_gotoxy(1, 2);
                disp_clean_line();
                printf("attitude: angle_a=%.3f \tangle_g=%.3f   \tangle=%.3f \tangle_car=%.3f\n\r", attitude_data.angle_a, attitude_data.angle_g, attitude_data.angle, attitude_data.angle_car);
#if BALANCE_TYPE == 1
                disp_gotoxy(1,3);
                disp_clean_line();
                printf("balance: balance_angle=%.3f \tkp=%.3f \tkd=%.3f \td_angle=%.3f \tax=%.3f \tangle=%.3f \n\r", balance_data.balance_angle, balance_data.kp, balance_data.kd, balance_data.d_angle, balance_data.ax, balance_data.angle);
#elif BALANCE_TYPE == 2
                disp_gotoxy(1,3);
                disp_clean_line();
                printf("balance: balance_angle=%.3f \tkp=%.3f \tkd=%.3f \td_angle=%.3f \tax=%.3f \tangle=%.3f \n\r", balance_data.balance_angle, balance_data.kp, balance_data.kd, balance_data.d_angle, balance_data.ax, balance_data.angle);
#endif
            }
            else if(disp_type == 1)     //ֱʾ
            {
#if BALANCE_TYPE == 1
                disp_gotoxy(8, 1);
                disp_clean_line();
                switch(focus)
                {
                case 0: printf("kp"); break;
                case 1: printf("kd"); break;
                case 2: printf("L"); break;
                case 3: printf("Lm"); break;
                case 4: printf("V"); break;
                }
                disp_gotoxy(1,2);
                printf("kp=%.3f  ", balance_data.kp);
                disp_gotoxy(8,2);
                printf("kd=%.3f  ", balance_data.kd);
                disp_gotoxy(1,3);
                printf("L=%.3f  ", balance_data.L);
                disp_gotoxy(8,3);
                printf("Lm=%.3f  ", balance_data.Lm);
                disp_gotoxy(1,4);
                printf("V=%.3f  ", balance_data.V);
                disp_gotoxy(8,4);
                printf("j=%.3f", balance_data.balance_angle);
#elif BALANCE_TYPE == 2
                disp_gotoxy(8, 1);
                disp_clean_line();
                switch(focus)
                {
                case 0: printf("kp"); break;
                case 1: printf("kd"); break;
                }
                disp_gotoxy(1,2);
                printf("kp=%.3f  ", balance_data.kp);
                disp_gotoxy(1,3);
                printf("kd=%.3f  ", balance_data.kd);
#endif
            }
        }
    }
}
